<?php

/*
CardDAV example
NetWin implemented based on modified SabreDAV implementation
VERSION:1.0
*/

$phplib=getenv("SURGEMAIL_ROOT")."/phplib";
require_once "$phplib/netwin/debug.php";
require_once "$phplib/".getenv("SABRE_VERSION")."/lib/Sabre/autoload.php";
require_once "$phplib/netwin/Nwauth_sabre.php";
$db="data/abkdb.sqlite";
dbg_init("abk.log");

dbg("----");
dbg("Sabre ABK");

// Make sure this setting is turned on and reflect the root url for your WebDAV server.
// This can be for example the root / or a complete path to your server script
$baseUri = '/abk';

/* Database */
$pdo = new PDO("sqlite:$db");
$pdo->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);

//Mapping PHP errors to exceptions
function exception_error_handler($errno, $errstr, $errfile, $errline ) {
    throw new ErrorException($errstr, 0, $errno, $errfile, $errline);
}
set_error_handler("exception_error_handler");

// Backends
$authBackend = new Sabre_DAV_Auth_Backend_Nwauth($pdo);
$principalBackend = new Sabre_DAVACL_PrincipalBackend_PDO($pdo);
$carddavBackend   = new Sabre_CardDAV_Backend_PDO($pdo);
//$caldavBackend    = new Sabre_CalDAV_Backend_PDO($pdo);

// Setting up the directory tree //
$nodes = array(
    new Sabre_DAVACL_PrincipalCollection($principalBackend),
//    new Sabre_CalDAV_CalendarRootNode($authBackend, $caldavBackend),
    new Sabre_CardDAV_AddressBookRoot($principalBackend, $carddavBackend),
);

// The object tree needs in turn to be passed to the server class
$server = new Sabre_DAV_Server($nodes);
$server->setBaseUri($baseUri);

// Plugins
$server->addPlugin(new Sabre_DAV_Auth_Plugin($authBackend,'SabreDAV'));
$server->addPlugin(new Sabre_DAV_Browser_Plugin());
//$server->addPlugin(new Sabre_CalDAV_Plugin());
$server->addPlugin(new Sabre_CardDAV_Plugin());
$server->addPlugin(new Sabre_DAVACL_Plugin());

// And off we go!
$server->exec();

dbg("Sabre ABK END");
