<?php

/*
CalendarServer example
NetWin implemented based on modified SabreDAV implementation
VERSION:1.0
*/

$phplib=getenv("SURGEMAIL_ROOT")."/phplib";
require_once "$phplib/netwin/debug.php";
require_once "$phplib/".getenv("SABRE_VERSION")."/lib/Sabre/autoload.php";
require_once "$phplib/netwin/Nwauth_sabre.php";
$db="data/caldb.sqlite";
dbg_init("cal.log");

dbg("----");
dbg("Sabre CAL");

error_reporting(E_ALL | E_STRICT);
assert_options(ASSERT_ACTIVE, 1);
assert_options(ASSERT_WARNING, 0);
assert_options(ASSERT_BAIL, 0);
assert_options(ASSERT_QUIET_EVAL, 0);
assert_options(ASSERT_CALLBACK, "assert_callcack");

if(getenv("CLUSTER_MASTER")!='TRUE'){
    print("ERROR: calendaring can only be used on the MASTER of a mirrorred cluster");
    return;
}


$baseUri = "/cal";
$pdo = new PDO("sqlite:$db");
$pdo->setAttribute(PDO::ATTR_ERRMODE,PDO::ERRMODE_EXCEPTION);

function exception_error_handler($errno, $errstr, $errfile, $errline ) {
	throw new ErrorException($errstr, 0, $errno, $errfile, $errline);
}
set_error_handler("exception_error_handler");
//$authBackend = new Sabre_DAV_Auth_Backend_PDO($pdo);
//$authBackend = new Sabre_DAV_Auth_Backend_File($davdata.'/.htdigest');
$authBackend = new Sabre_DAV_Auth_Backend_Nwauth($pdo);
$calendarBackend = new Sabre_CalDAV_Backend_PDO($pdo);
$principalBackend = new Sabre_DAVACL_PrincipalBackend_PDO($pdo);
$tree = array(
	new Sabre_CalDAV_Principal_Collection($principalBackend),
	new Sabre_CalDAV_CalendarRootNode($principalBackend, $calendarBackend),
);

$server = new Sabre_DAV_Server($tree);
if (isset($baseUri))
	$server->setBaseUri($baseUri);

$authPlugin = new Sabre_DAV_Auth_Plugin($authBackend,'SabreDAV');
$server->addPlugin($authPlugin);
$aclPlugin = new Sabre_DAVACL_Plugin();
$server->addPlugin($aclPlugin);
$caldavPlugin = new Sabre_CalDAV_Plugin();
$server->addPlugin($caldavPlugin);
$browser = new Sabre_DAV_Browser_Plugin();
$server->addPlugin($browser);

// And off we go!
$server->exec();

dbg("Sabre CAL END");
